import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class WorkflowExecutionService extends AbstractService<WorkflowExecutions> {
  @override
  late final APIService<WorkflowExecutions> service;

  @override
  String subPath = "/";

  WorkflowExecutionService() {
    service = APIService<WorkflowExecutions>(
        baseURL: super.conf.get('SCHEDULER_HOST',
            defaultValue: 'http://localhost:8080/scheduler'));
  }
  @override
  Future<APIResponse<WorkflowExecutions>> search(
      BuildContext? context, List<String> words, Map<String, dynamic> params) {
    return service.get("${subPath}search/${words.join("/")}", false, context);
  }

  @override
  Future<APIResponse<WorkflowExecutions>> post(BuildContext? context,
      Map<String, dynamic> body, Map<String, String> params) {
    return throw UnimplementedError();
  }

  @override
  Future<APIResponse<WorkflowExecutions>> put(BuildContext? context, String id,
      Map<String, dynamic> body, Map<String, String> params) {
    return throw UnimplementedError();
  }
}
